#pragma once
#include "Format/Entity.hpp"


namespace TestGame {

    class GameEntity : public Entity
    {

    public:
        float gravity = 9.8f;
        float mass = 12.f;
        float air_resistance = 8.f;
        float friction = 0.001f;
        float acceleration = 1200;

        GameEntity(const Vector2& spawn_pos) {
            pos = spawn_pos;
            next_pos = spawn_pos;
        }

        virtual void Update(float elapsed) = 0;

        virtual void Draw() = 0;

        Vector2 pos;
        Vector2 next_pos;
        Vector2 bbox;
        Vector2 velocity;
        bool noclip = false;
        bool on_ground = true;
    };
}
