#pragma once
#include <Format/Tileset.hpp>
#include <JUI/Base/Widget.hpp>
#include <JUI/Widgets/Window.hpp>
#include <JUI/Widgets/Checkbox.hpp>
#include <JUI/Widgets/TextInputForm.hpp>

    ///
    class TileMetaDialog : public JUI::Window, public JUI::Hoverable {
    public:
        Event<bool> CollidesChanged;
        Event<std::string> NameChanged;

        TileMetaDialog();

        explicit TileMetaDialog(JUI::Widget* parent);

        void SetTileMetadata(const Tile& tile);

        [[nodiscard]] int CurrentTileID() const;

        [[nodiscard]] std::string CurrentTileName() const;

        void OnExit(const Vector2 &MousePos) override;

        JUI::TextRect* name_label;
        JUI::TextInputForm* name_form;
        JUI::TextRect* collides_label;
        JUI::Checkbox* collides_form;

        int cur_tile_id;
        std::string cur_tile_name;




        protected:
        private:
    };
