#include <ReWindow/InputService.h>
#include <DemoGame/Player.hpp>
#include <JGL/JGL.h>

TestGame::Player::Player(const Vector2 &spawn_pos): GameEntity(spawn_pos) {
    bbox = {16, 24};
}

TestGame::Player::~Player() {

}

void TestGame::Player::Update(float elapsed) {
    // Update current position to our next_position, which was computed on the last frame.
    // This means we can collision solve our next_pos in between calls to entity->Update();
    pos = next_pos;

    velocity.x *= 1 - (elapsed * air_resistance);
    //velocity.y *= 1 - (elapsed * air_resistance);

    //if (on_ground)
    //velocity.x *= friction;

    velocity.y += (elapsed*gravity*mass);

    next_pos += velocity * elapsed;

    if (Math::Abs(velocity.y) > 2)
        on_ground = false;


    if (InputService::IsKeyDown(Keys::A))
        velocity.x -= acceleration * elapsed;

    if (InputService::IsKeyDown(Keys::D))
        velocity.x += acceleration * elapsed;

    if (InputService::IsKeyDown(Keys::W))
        velocity.y -= acceleration * elapsed;

    if (InputService::IsKeyDown(Keys::S))
        velocity.y += acceleration * elapsed;
}

void TestGame::Player::Draw() {
    J2D::FillRect(Colors::Blue, pos, bbox);
    J2D::DrawPartialSprite(sprite, pos, {0,0}, bbox);
}
