#include <Editor/EditorCamera.hpp>

Matrix4x4 EditorCamera::CurrentTranslationMatrix() const
{
    return Matrix4x4::FromTranslation({translation.current.x, translation.current.y, 0});
}

Matrix4x4 EditorCamera::GoalTranslationMatrix() const
{
    return Matrix4x4::FromTranslation({translation.goal.x, translation.goal.y, 0});
}

Matrix4x4 EditorCamera::CurrentRotationMatrix() const
{
    // TODO: Which axis?
    return Matrix4x4::RotateX(rotation.current);
}

Matrix4x4 EditorCamera::GoalRotationMatrix() const
{
    // TODO: Which axis?
    return Matrix4x4::RotateX(rotation.goal);
}

Matrix4x4 EditorCamera::CurrentScaleMatrix() const
{
    return Matrix4x4::Scale({scale.current, scale.current, 1});
}
