#include <Format/Entity.hpp>

Entity::Entity():
    x(0), y(0),
    width(0), height(0),
    rotation(0),
    flip_h(0), flip_v(0),
    z_index(0),
    overlay_color() {

}

Entity::Entity(const json::value &json) {
    Deserialize(json);
}

json::value Entity::Serialize() const {
    json::object data;
    data["name"] = this->name;
    data["type"] = this->type;
    data["x"] = this->x;
    data["y"] = this->y;
    data["width"] = this->width;
    data["height"] = this->height;
    data["rotation"] = this->rotation;
    data["flip-h"] = this->flip_h;
    data["flip-v"] = this->flip_v;
    data["z-index"] = (float)this->z_index;
    data["color"] = JsonConversions::deparse_color_to_hex(overlay_color);
    data["metadata"] = this->metadata;
    return data;
}

void Entity::Deserialize(const json::value &json) {
    name = json["name"].as_string();
    type = json["type"].as_string();
    x = json["x"].number.value();
    y = json["y"].number.value();
    width = json["width"].number.value_or(0);
    height = json["height"].number.value_or(0);
    rotation = json["rotation"].number.value_or(0);
    //flip_h = json["flip-h"].boolean.value();
    //flip_v = json["flip-v"].boolean.value();
    z_index = json["z-index"].number.value();
    // TODO: sscanf is bad!!!
    //overlay_color = JsonConversions::parse_color(json["color"]);
    metadata = json["metadata"];


}
